#include "ESP8266.h"
#include "Timer.h"
#define SSID_NAME     "ITT"
#define PASSWORD  "12345678"
#define HOST_NAME  "api.wunderground.com"
#define HOST_PORT  (80)
#define BUFFER_SIZE   (400)
#define API_KEY "825673f1354b4021"
ESP8266 wifi(Serial1); 
static Timer join_ap_timer;
static int8_t  join_ap_timer_id = -1;
static Timer tcp_timer;
static int8_t tcp_timer_id = -1;
static Timer read_uart_timer;
static int8_t read_uart_timer_id = -1;
static String state =  "Australia";
static String city = "Sydney";
String json_forecast = "";
char* forecast[]={"\"celsius\":","\"celsius\":","\"icon\":","\"avehumidity\":","\"celsius\":","\"celsius\":","\"icon\":","\"avehumidity\":"};
char* conds[]={"Date: ","\"weather\":","\"temp_c\":","\"relative_humidity\":","\"wind_dir\":","\"wind_kph\":"};
String weeks[7]={"Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"};
String rain="Drizzle, Rain, Snow, Snow Grains, Ice Crystals, Ice Pellets, Hail, Low Drifting Snow,Blowing Snow,Rain Mist,Rain Showers, Snow Showers, Snow Blowing Snow Mist, Ice Pellet Showers, Hail Showers, Small Hail Showers,Freezing Drizzle,Freezing Rain, Small Hail, chanceflurries,chancerain,chancesleet,chancesnow,sleet, rain, snow";
String thunde="Thunderstorm, Thunderstorms and Rain, Thunderstorms and Snow, Thunderstorms and Ice Pellets, Thunderstorms with Hail, Thunderstorms with Small Hail,chancetstorms, tstorms";
String sunny="Clear, Unknown Precipitation, Unknown, sunny, unknown";
String cloudy ="Overcast ,Mist, Fog, FogPatches, Smoke, VolcanicAsh, WidespreadDust,Sand, Haze, Spray, DustWhirls, Sandstorm, LowDrifting WidespreadDust, LowDriftingSand, BlowingWidespreadDust, BlowingSand, FreezingFog, PatchesofFog, ShallowFog, PartlyCloudy, MostlyCloudy, ScatteredClouds, Squalls, FunnelCloud,cloudy,flurries,fog,hazy, mostlycloudy, mostlysunny, partlycloudy, partlysunny";
typedef struct _forecast_data{
    String one_temp;
    String one_weather_type;
    String one_humi;
    String two_temp;
    String two_weather_type;
    String two_humi;
}forecast_datas;

typedef struct _current_data {
    String week_time;
    String tom1;
    String tom2;
    String date;
    String temp;
    String weather_type;
    String hum;
    String wind;
}current_datas;

forecast_datas forecast_data;
current_datas current_data;

void sendToLCD(uint8_t type,String index, String cmd){
    while(Serial2.available() > 0){
        Serial2.read();
    }
    if(type == 1){
        Serial2.print(index);
        Serial2.print(".txt=");
        Serial2.print("\"");
        Serial2.print(cmd);
        Serial2.print("\"");
    }else if (type == 2){
        Serial2.print(index);
        Serial2.print(".val=");
        Serial2.print(cmd);
    }else if (type == 3){
        Serial2.print(index);
        Serial2.print(".picc="); 
        Serial2.print(cmd);
    }else if (type ==4 ){
        Serial2.print("page ");
        Serial2.print(cmd);
    }
    Serial2.write(0xff);
    Serial2.write(0xff);
    Serial2.write(0xff);
}
void createTcpConnect(void){
    static uint8_t counter = 0;
    counter++;
    String status_temp = wifi.getIPStatus();
    Serial.println(status_temp); 
    static bool first_update = true;
    if(-1 == status_temp.indexOf("STATUS:2") && -1 == status_temp.indexOf("STATUS:3")){
        tcp_timer.stop(tcp_timer_id);
        tcp_timer_id = -1;
        if(join_ap_timer_id == -1){
            join_ap_timer_id = join_ap_timer.every(2000,joinAp);
        }
    }
    else{
        if(-1 == status_temp.indexOf("STATUS:3")){
        Serial.print("create tcp connect :");
        if(wifi.createTCP(HOST_NAME,HOST_PORT)){
                Serial.println("create tcp ok");
                counter = 0;
                tcp_timer.stop(tcp_timer_id);
                tcp_timer_id = -1;
                if(first_update){
                    first_update = false;
                    getForecastData();
                    getCurrentData();
                    sendWeatherData();
                    if(read_uart_timer_id == -1){
                        read_uart_timer_id = read_uart_timer.every(50,readUart);
                    }
              }
            }
            else{
                Serial.print("try ");
                Serial.print(counter ,DEC);
                Serial.println(" timer again");
                if(counter >= 3){
                    counter = 0;
                    Serial.println("disconnect tcp, and try again");
                    wifi.releaseTCP();      
                }
            }
        }
        else{
            Serial.println("tcp server had been connected");
            tcp_timer.stop(tcp_timer_id);
            tcp_timer_id = -1;
        }
    }
  }
void joinAp(void){
    static uint8_t counter = 0;
    counter++;
    Serial.println("begin to join ap");
    wifi.setOprToStation();
    if(wifi.joinAP(SSID_NAME,PASSWORD)){
        Serial.println("Join AP successful");
        if(wifi.disableMUX()){
            Serial.println("change to single ok");
            counter = 0;
            join_ap_timer.stop(join_ap_timer_id);
            join_ap_timer_id = -1;
            if(tcp_timer_id == -1){
                tcp_timer_id = tcp_timer.every(2000,createTcpConnect);
                Serial.println(tcp_timer_id);
            }
        }
        else{
            Serial.println("change to single error");
        }
    }
    else{
        Serial.print("try ");
        Serial.print(counter ,DEC);
        Serial.println(" timer again");
        if(counter >= 3){
            counter = 0;
            Serial.println("check your wifi ssid and password");
            wifi.leaveAP();      
          }
      }
  }

void readUart(void){
      char buffer[BUFFER_SIZE] = {0};
      static String state_city = "";
      uint8_t length_temp = Serial2.available();
      
      if(length_temp > 0){
          Serial2.readBytes(buffer,length_temp);
          String state_city_temp = String(buffer);
          state_city += state_city_temp ;
          if(state_city.charAt('\r')  && state_city.charAt('\n')){
              if(state_city.indexOf('-') == -1){
                  state_city = "";
                  return;  
              }
              Serial.println("the buffer begin");
              Serial.println(state_city);
              uint8_t index1 = state_city.indexOf('-');
              uint8_t index2 = state_city.indexOf('-',index1+1);
              uint8_t index3 = state_city.indexOf('-',index2+1);
              if(index1 != -1 && index2 != -1 && index3 != -1){
                state = state_city.substring(index1+1,index2);
                city = state_city.substring(index2+1,index3);
                  Serial.print("state : ");
                  Serial.println(state);
                  Serial.print("city :  ");
                  Serial.println(city);
                  state_city = "";
                  read_uart_timer.stop(read_uart_timer_id);
                  read_uart_timer_id = -1;
                  getForecastData();
                  sendToLCD(2,"j0","50");
                  getCurrentData();
                  sendToLCD(2,"j0","100");
                  sendToLCD(4,"","0");
                  sendWeatherData();
                  while(Serial2.available()){
                      Serial2.read();  
                  }
                  if(read_uart_timer_id == -1){
                      read_uart_timer_id = read_uart_timer.every(50,readUart);
                }
              }
              else{
                  Serial.println("you input should be -state-city-");
              }
          }
      }
}

void getForecastData(void){
    uint8_t i;
    String temp_string[8];
    unsigned long start;
    String status_temp = wifi.getIPStatus();
    Serial.println(status_temp);
    if(-1 == status_temp.indexOf("STATUS:3")){
          Serial.println("tcp is disconnected");
          if(tcp_timer_id == -1){
              tcp_timer_id = tcp_timer.every(2000,createTcpConnect);
              Serial.println(tcp_timer_id);
          }
         
    }else{
        Serial.println("will send data to get forcast data");
        String get_forcast_data_cmd = "GET /api/" + String(API_KEY) + "/forecast/q/"+state+"/"+city+".json"+" HTTP/1.1\r\nHost: api.wunderground.com\r\n" + "Connection:Keep-Alive\r\n\r\n";
        Serial.println(get_forcast_data_cmd);
        if(wifi.send((const uint8_t *)get_forcast_data_cmd.c_str(),get_forcast_data_cmd.length())){
            Serial.println("send data ok");  
        }else{
            Serial.println("send data error"); 
        }
        
        if(!Serial1.find("\"simpleforecast\": {")){
            Serial.println("not find simple"); 
        }
        
        if(!Serial1.find("\"minhumidity\":")){
            Serial.println("not find minhunidity");  
        }
        for(i = 0; i < 8 ; i++){
            temp_string[i] = dealData(forecast[i]);
        }
        forecast_data.one_temp = temp_string[0] + "C-" + temp_string[1] + "C";
        forecast_data.one_weather_type = temp_string[2];
        forecast_data.one_humi = temp_string[3];
        forecast_data.two_temp = temp_string[4] + "C-" + temp_string[5] + "C";
        forecast_data.two_weather_type = temp_string[6];
        forecast_data.two_humi = temp_string[7];
        Serial.println(forecast_data.one_temp);
        Serial.println(forecast_data.one_weather_type);
        Serial.println(forecast_data.one_humi);
        Serial.println(forecast_data.two_temp);
        Serial.println(forecast_data.two_weather_type);
        Serial.println(forecast_data.two_humi);
    }
}
String dealData(char *s){
      uint8_t i;
      String temp = "";
      unsigned long start;
      start = millis();
      for(i = 0; i < 3; i++){
          if(Serial1.find(s)){
              while (millis() - start < 1000){
              if(Serial1.available()){
                  char c = Serial1.read();  
                  if(String(s).equals("Date: ")){
                      if(c == 0x0d){
                          break;  
                      }  
                  }else{
                      if(c == ',' || c == '}'){
                          break;  
                      }
                      if(c == '\"' || c == '\"' || c == 0x0d || c == 0x09 || c == 0x20 || c == 0x0a){
                          continue;  
                      }
                  }
                  temp += c;
              } 
          }
          Serial.println(temp);
          return temp;
      }     
      else{
          Serial.println("not found");  
      }
   }
}

void getTime(String data){
    uint8_t i;
    String week_data;
    String week_temp = data.substring(0,data.indexOf(','));
    Serial.println(week_temp);
    for(i = 0; i < 7; i++){
        if(-1 != weeks[i].indexOf(week_temp)){
              week_data = weeks[i];
              if(i == 4){
                  current_data.tom1 = weeks[5];
                  current_data.tom2 = weeks[6]; 
              }else if(i == 5){
                  current_data.tom1 = weeks[6];
                  current_data.tom2 = weeks[1];
              }
              i = 8;
              break;
        }  
    }
    if(i != 8){
        Serial.println("0get wekk data error");  
    }
    current_data.date = data.substring((data.indexOf(',') + 2),(data.indexOf(':') - 3));
    current_data.week_time = week_data + " " + data.substring((data.indexOf(':') - 2),(data.indexOf(':') + 3));
    Serial.println(current_data.date);
    Serial.println(current_data.week_time);
    
}
void sendWeatherData(void){
    sendToLCD(1,"t2"," ");
    sendToLCD(1,"t0",city);
    sendToLCD(1,"t2",current_data.date);
    sendToLCD(1,"t1",current_data.week_time);
    sendToLCD(1,"t3",current_data.temp);
    sendToLCD(1,"t7",current_data.wind);
    sendToLCD(1,"t8",current_data.weather_type);
    sendToLCD(1,"t10",current_data.hum);
    sendToLCD(1,"t11",current_data.tom1);
    sendToLCD(1,"t15",current_data.tom2);
    sendToLCD(1,"t13",forecast_data.one_humi);
    sendToLCD(1,"t14",forecast_data.one_temp);
    sendToLCD(1,"t18",forecast_data.two_humi);
    sendToLCD(1,"t16",forecast_data.two_temp);
    if(rain.indexOf(current_data.weather_type)!=-1){
        sendToLCD(3,"q0","11");
    }
    else if(thunde.indexOf(current_data.weather_type)!=-1){
        sendToLCD(3,"q0","12");
    }
   else if(cloudy.indexOf(current_data.weather_type)!=-1){
       sendToLCD(3,"q0","14");
   }
   else{
       sendToLCD(3,"q0","10");
   }
   if(rain.indexOf(forecast_data.one_weather_type)!=-1){
        sendToLCD(3,"q1","5");
    }
    else if(thunde.indexOf(forecast_data.one_weather_type)!=-1){
        sendToLCD(3,"q1","7");
    }
   else if(cloudy.indexOf(forecast_data.one_weather_type)!=-1){
       sendToLCD(3,"q1","9");
   }
   else{
       sendToLCD(3,"q1","3");
   }
   
   if(rain.indexOf(forecast_data.two_weather_type)!=-1){
        sendToLCD(3,"q2","4");
    }
    else if(thunde.indexOf(forecast_data.two_weather_type)!=-1){
        sendToLCD(3,"q2","6");
    }
   else if(cloudy.indexOf(forecast_data.two_weather_type)!=-1){
       sendToLCD(3,"q2","8");
   }
   else{
       sendToLCD(3,"q2","2");
   }
}
void getCurrentData(){
    uint8_t i;
    String temp_string[6];
    unsigned long start;
    String status_temp = wifi.getIPStatus();
    Serial.println(status_temp);
    if(-1 == status_temp.indexOf("STATUS:3")){
          Serial.println("tcp is disconnected");
          if(tcp_timer_id == -1){
              tcp_timer_id = tcp_timer.every(2000,createTcpConnect);
              Serial.println(tcp_timer_id);
          }
    }else{
        Serial.println("will send data to get current data");
        String get_current_data_cmd = "GET /api/" + String(API_KEY) + "/conditions/q/"+state+"/"+city+".json"+" HTTP/1.1\r\nHost: api.wunderground.com\r\n" + "Connection:Keep-Alive\r\n\r\n";
        Serial.println(get_current_data_cmd);
        if(wifi.send((const uint8_t *)get_current_data_cmd.c_str(),get_current_data_cmd.length())){
            Serial.println("send data ok");  
        }else{
            Serial.println("send data error"); 
        }
        for(i = 0; i < 6 ; i++){
            temp_string[i] = dealData(conds[i]);
        }
        getTime(temp_string[0]);
        current_data.temp = temp_string[2];
        current_data.weather_type = temp_string[1];
        current_data.hum = temp_string[3];
        current_data.wind = temp_string[4] + "  " + temp_string[5] + "KM/H";
        Serial.println(current_data.temp);
        Serial.println(current_data.weather_type);
        Serial.println(current_data.hum);
        Serial.println(current_data.wind);        
    }
}
void setup() {
  // put your setup code here, to run once:
    Serial.begin(9600);
    Serial2.begin(9600);
    Serial.println("start");
    Serial1.flush();
    join_ap_timer_id = join_ap_timer.every(2000,joinAp);
    //read_uart_timer.every(50,readUart);
  }

void loop() {
  // put your main code here, to run repeatedly:
    join_ap_timer.update();
    tcp_timer.update();
    read_uart_timer.update();
  }
